package com.toughra.ustadmobile.databinding;
import com.toughra.ustadmobile.R;
import com.toughra.ustadmobile.BR;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import android.view.View;
@SuppressWarnings("unchecked")
public class ItemCourseBlockCommonDetailBindingImpl extends ItemCourseBlockCommonDetailBinding  {

    @Nullable
    private static final androidx.databinding.ViewDataBinding.IncludedLayouts sIncludes;
    @Nullable
    private static final android.util.SparseIntArray sViewsWithIds;
    static {
        sIncludes = null;
        sViewsWithIds = new android.util.SparseIntArray();
        sViewsWithIds.put(R.id.ca_start_datetime_textinput, 21);
        sViewsWithIds.put(R.id.ca_edit_completion_criteria, 22);
    }
    // views
    @NonNull
    private final androidx.constraintlayout.widget.ConstraintLayout mboundView0;
    @NonNull
    private final com.google.android.material.textfield.TextInputEditText mboundView13;
    @NonNull
    private final com.google.android.material.textfield.TextInputEditText mboundView17;
    @NonNull
    private final com.google.android.material.textfield.TextInputEditText mboundView3;
    @NonNull
    private final com.ustadmobile.port.android.view.IdOptionAutoCompleteTextView mboundView5;
    // variables
    // values
    // listeners
    // Inverse Binding Event Handlers
    private androidx.databinding.InverseBindingListener caDeadlineDatedateTimeInMillisAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of deadlineDate
            //         is com.toughra.ustadmobile.databinding.ItemCourseBlockCommonDetailBindingImpl.this.setDeadlineDate(callbackArg_0)
            long callbackArg_0 = com.ustadmobile.port.android.view.binding.DatePickerBindingAdapter2Kt.getDateTimeInMillis(caDeadlineDate);
            // localize variables for thread safety
            // deadlineDate
            long deadlineDate = mDeadlineDate;


            if ((com.toughra.ustadmobile.databinding.ItemCourseBlockCommonDetailBindingImpl.this) != (null)) {



                com.toughra.ustadmobile.databinding.ItemCourseBlockCommonDetailBindingImpl.this.setDeadlineDate(callbackArg_0);
            }
        }
    };
    private androidx.databinding.InverseBindingListener caEditMaxScoreandroidTextAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of ("") + (block.cbMaxPoints)
            //         is block.setCbMaxPoints((int) androidx.databinding.ViewDataBinding.parse(callbackArg_0, block.cbMaxPoints))
            java.lang.String callbackArg_0 = androidx.databinding.adapters.TextViewBindingAdapter.getTextString(caEditMaxScore);
            // localize variables for thread safety
            // block.cbMaxPoints
            int blockCbMaxPoints = 0;
            // (int) androidx.databinding.ViewDataBinding.parse(callbackArg_0, block.cbMaxPoints)
            int intAndroidxDatabindingViewDataBindingParseCallbackArg0BlockCbMaxPoints = 0;
            // androidx.databinding.ViewDataBinding.parse(callbackArg_0, block.cbMaxPoints)
            int androidxDatabindingViewDataBindingParseCallbackArg0BlockCbMaxPoints = 0;
            // block
            com.ustadmobile.lib.db.entities.CourseBlock block = mBlock;
            // ("") + (block.cbMaxPoints)
            java.lang.String javaLangStringBlockCbMaxPoints = null;
            // block != null
            boolean blockJavaLangObjectNull = false;



            blockJavaLangObjectNull = (block) != (null);
            if (blockJavaLangObjectNull) {





                blockCbMaxPoints = block.getCbMaxPoints();

                androidxDatabindingViewDataBindingParseCallbackArg0BlockCbMaxPoints = androidx.databinding.ViewDataBinding.parse(callbackArg_0, blockCbMaxPoints);

                intAndroidxDatabindingViewDataBindingParseCallbackArg0BlockCbMaxPoints = ((int) (androidxDatabindingViewDataBindingParseCallbackArg0BlockCbMaxPoints));

                block.setCbMaxPoints(intAndroidxDatabindingViewDataBindingParseCallbackArg0BlockCbMaxPoints);
            }
        }
    };
    private androidx.databinding.InverseBindingListener caEditMinScoreandroidTextAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of ("") + (block.cbMaxPoints)
            //         is block.setCbMaxPoints((int) androidx.databinding.ViewDataBinding.parse(callbackArg_0, block.cbMaxPoints))
            java.lang.String callbackArg_0 = androidx.databinding.adapters.TextViewBindingAdapter.getTextString(caEditMinScore);
            // localize variables for thread safety
            // block.cbMaxPoints
            int blockCbMaxPoints = 0;
            // (int) androidx.databinding.ViewDataBinding.parse(callbackArg_0, block.cbMaxPoints)
            int intAndroidxDatabindingViewDataBindingParseCallbackArg0BlockCbMaxPoints = 0;
            // androidx.databinding.ViewDataBinding.parse(callbackArg_0, block.cbMaxPoints)
            int androidxDatabindingViewDataBindingParseCallbackArg0BlockCbMaxPoints = 0;
            // block
            com.ustadmobile.lib.db.entities.CourseBlock block = mBlock;
            // ("") + (block.cbMaxPoints)
            java.lang.String javaLangStringBlockCbMaxPoints = null;
            // block != null
            boolean blockJavaLangObjectNull = false;



            blockJavaLangObjectNull = (block) != (null);
            if (blockJavaLangObjectNull) {





                blockCbMaxPoints = block.getCbMaxPoints();

                androidxDatabindingViewDataBindingParseCallbackArg0BlockCbMaxPoints = androidx.databinding.ViewDataBinding.parse(callbackArg_0, blockCbMaxPoints);

                intAndroidxDatabindingViewDataBindingParseCallbackArg0BlockCbMaxPoints = ((int) (androidxDatabindingViewDataBindingParseCallbackArg0BlockCbMaxPoints));

                block.setCbMaxPoints(intAndroidxDatabindingViewDataBindingParseCallbackArg0BlockCbMaxPoints);
            }
        }
    };
    private androidx.databinding.InverseBindingListener caEditPenaltyandroidTextAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of ("") + (block.cbLateSubmissionPenalty)
            //         is block.setCbLateSubmissionPenalty((int) androidx.databinding.ViewDataBinding.parse(callbackArg_0, block.cbLateSubmissionPenalty))
            java.lang.String callbackArg_0 = androidx.databinding.adapters.TextViewBindingAdapter.getTextString(caEditPenalty);
            // localize variables for thread safety
            // androidx.databinding.ViewDataBinding.parse(callbackArg_0, block.cbLateSubmissionPenalty)
            int androidxDatabindingViewDataBindingParseCallbackArg0BlockCbLateSubmissionPenalty = 0;
            // (int) androidx.databinding.ViewDataBinding.parse(callbackArg_0, block.cbLateSubmissionPenalty)
            int intAndroidxDatabindingViewDataBindingParseCallbackArg0BlockCbLateSubmissionPenalty = 0;
            // block
            com.ustadmobile.lib.db.entities.CourseBlock block = mBlock;
            // block != null
            boolean blockJavaLangObjectNull = false;
            // ("") + (block.cbLateSubmissionPenalty)
            java.lang.String javaLangStringBlockCbLateSubmissionPenalty = null;
            // block.cbLateSubmissionPenalty
            int blockCbLateSubmissionPenalty = 0;



            blockJavaLangObjectNull = (block) != (null);
            if (blockJavaLangObjectNull) {





                blockCbLateSubmissionPenalty = block.getCbLateSubmissionPenalty();

                androidxDatabindingViewDataBindingParseCallbackArg0BlockCbLateSubmissionPenalty = androidx.databinding.ViewDataBinding.parse(callbackArg_0, blockCbLateSubmissionPenalty);

                intAndroidxDatabindingViewDataBindingParseCallbackArg0BlockCbLateSubmissionPenalty = ((int) (androidxDatabindingViewDataBindingParseCallbackArg0BlockCbLateSubmissionPenalty));

                block.setCbLateSubmissionPenalty(intAndroidxDatabindingViewDataBindingParseCallbackArg0BlockCbLateSubmissionPenalty);
            }
        }
    };
    private androidx.databinding.InverseBindingListener caGraceDatedateTimeInMillisAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of gracePeriodDate
            //         is com.toughra.ustadmobile.databinding.ItemCourseBlockCommonDetailBindingImpl.this.setGracePeriodDate(callbackArg_0)
            long callbackArg_0 = com.ustadmobile.port.android.view.binding.DatePickerBindingAdapter2Kt.getDateTimeInMillis(caGraceDate);
            // localize variables for thread safety
            // gracePeriodDate
            long gracePeriodDate = mGracePeriodDate;


            if ((com.toughra.ustadmobile.databinding.ItemCourseBlockCommonDetailBindingImpl.this) != (null)) {



                com.toughra.ustadmobile.databinding.ItemCourseBlockCommonDetailBindingImpl.this.setGracePeriodDate(callbackArg_0);
            }
        }
    };
    private androidx.databinding.InverseBindingListener caStartDatedateTimeInMillisAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of startDate
            //         is com.toughra.ustadmobile.databinding.ItemCourseBlockCommonDetailBindingImpl.this.setStartDate(callbackArg_0)
            long callbackArg_0 = com.ustadmobile.port.android.view.binding.DatePickerBindingAdapter2Kt.getDateTimeInMillis(caStartDate);
            // localize variables for thread safety
            // startDate
            long startDate = mStartDate;


            if ((com.toughra.ustadmobile.databinding.ItemCourseBlockCommonDetailBindingImpl.this) != (null)) {



                com.toughra.ustadmobile.databinding.ItemCourseBlockCommonDetailBindingImpl.this.setStartDate(callbackArg_0);
            }
        }
    };
    private androidx.databinding.InverseBindingListener mboundView13timeValueAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of deadlineTime
            //         is com.toughra.ustadmobile.databinding.ItemCourseBlockCommonDetailBindingImpl.this.setDeadlineTime(callbackArg_0)
            long callbackArg_0 = com.ustadmobile.port.android.view.binding.TimePickerBindingAdapterKt.getTimeValue(mboundView13);
            // localize variables for thread safety
            // deadlineTime
            long deadlineTime = mDeadlineTime;


            if ((com.toughra.ustadmobile.databinding.ItemCourseBlockCommonDetailBindingImpl.this) != (null)) {



                com.toughra.ustadmobile.databinding.ItemCourseBlockCommonDetailBindingImpl.this.setDeadlineTime(callbackArg_0);
            }
        }
    };
    private androidx.databinding.InverseBindingListener mboundView17timeValueAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of gracePeriodTime
            //         is com.toughra.ustadmobile.databinding.ItemCourseBlockCommonDetailBindingImpl.this.setGracePeriodTime(callbackArg_0)
            long callbackArg_0 = com.ustadmobile.port.android.view.binding.TimePickerBindingAdapterKt.getTimeValue(mboundView17);
            // localize variables for thread safety
            // gracePeriodTime
            long gracePeriodTime = mGracePeriodTime;


            if ((com.toughra.ustadmobile.databinding.ItemCourseBlockCommonDetailBindingImpl.this) != (null)) {



                com.toughra.ustadmobile.databinding.ItemCourseBlockCommonDetailBindingImpl.this.setGracePeriodTime(callbackArg_0);
            }
        }
    };
    private androidx.databinding.InverseBindingListener mboundView3timeValueAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of startTime
            //         is com.toughra.ustadmobile.databinding.ItemCourseBlockCommonDetailBindingImpl.this.setStartTime(callbackArg_0)
            long callbackArg_0 = com.ustadmobile.port.android.view.binding.TimePickerBindingAdapterKt.getTimeValue(mboundView3);
            // localize variables for thread safety
            // startTime
            long startTime = mStartTime;


            if ((com.toughra.ustadmobile.databinding.ItemCourseBlockCommonDetailBindingImpl.this) != (null)) {



                com.toughra.ustadmobile.databinding.ItemCourseBlockCommonDetailBindingImpl.this.setStartTime(callbackArg_0);
            }
        }
    };
    private androidx.databinding.InverseBindingListener mboundView5selectedMessageIdOptionAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of block.cbCompletionCriteria
            //         is block.setCbCompletionCriteria((int) callbackArg_0)
            int callbackArg_0 = com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.getSelectedMessageIdOption(mboundView5);
            // localize variables for thread safety
            // block
            com.ustadmobile.lib.db.entities.CourseBlock block = mBlock;
            // block != null
            boolean blockJavaLangObjectNull = false;
            // block.cbCompletionCriteria
            int blockCbCompletionCriteria = 0;



            blockJavaLangObjectNull = (block) != (null);
            if (blockJavaLangObjectNull) {




                block.setCbCompletionCriteria(((int) (callbackArg_0)));
            }
        }
    };

    public ItemCourseBlockCommonDetailBindingImpl(@Nullable androidx.databinding.DataBindingComponent bindingComponent, @NonNull View root) {
        this(bindingComponent, root, mapBindings(bindingComponent, root, 23, sIncludes, sViewsWithIds));
    }
    private ItemCourseBlockCommonDetailBindingImpl(androidx.databinding.DataBindingComponent bindingComponent, View root, Object[] bindings) {
        super(bindingComponent, root, 0
            , (com.google.android.material.textfield.TextInputEditText) bindings[11]
            , (com.google.android.material.textfield.TextInputLayout) bindings[10]
            , (com.google.android.material.textfield.TextInputLayout) bindings[12]
            , (com.google.android.material.textfield.TextInputLayout) bindings[22]
            , (com.google.android.material.textfield.TextInputEditText) bindings[9]
            , (com.google.android.material.textfield.TextInputLayout) bindings[8]
            , (com.google.android.material.textfield.TextInputEditText) bindings[7]
            , (com.google.android.material.textfield.TextInputEditText) bindings[19]
            , (com.google.android.material.textfield.TextInputLayout) bindings[18]
            , (com.google.android.material.textfield.TextInputEditText) bindings[15]
            , (com.google.android.material.textfield.TextInputLayout) bindings[14]
            , (com.google.android.material.textfield.TextInputLayout) bindings[16]
            , (android.widget.TextView) bindings[20]
            , (com.google.android.material.textfield.TextInputEditText) bindings[2]
            , (com.google.android.material.textfield.TextInputLayout) bindings[1]
            , (com.google.android.material.textfield.TextInputLayout) bindings[21]
            , (android.widget.TextView) bindings[4]
            , (com.google.android.material.textfield.TextInputLayout) bindings[6]
            );
        this.caDeadlineDate.setTag(null);
        this.caDeadlineDateTextinput.setTag(null);
        this.caDeadlineDatetimeTextinput.setTag(null);
        this.caEditMaxScore.setTag(null);
        this.caEditMaxScroreTextinput.setTag(null);
        this.caEditMinScore.setTag(null);
        this.caEditPenalty.setTag(null);
        this.caEditPenaltyTextinput.setTag(null);
        this.caGraceDate.setTag(null);
        this.caGraceDateTextinput.setTag(null);
        this.caGraceDatetimeTextinput.setTag(null);
        this.caPenaltyTextLabel.setTag(null);
        this.caStartDate.setTag(null);
        this.caStartDateTextinput.setTag(null);
        this.caTimezone.setTag(null);
        this.courseBlockMinScore.setTag(null);
        this.mboundView0 = (androidx.constraintlayout.widget.ConstraintLayout) bindings[0];
        this.mboundView0.setTag(null);
        this.mboundView13 = (com.google.android.material.textfield.TextInputEditText) bindings[13];
        this.mboundView13.setTag(null);
        this.mboundView17 = (com.google.android.material.textfield.TextInputEditText) bindings[17];
        this.mboundView17.setTag(null);
        this.mboundView3 = (com.google.android.material.textfield.TextInputEditText) bindings[3];
        this.mboundView3.setTag(null);
        this.mboundView5 = (com.ustadmobile.port.android.view.IdOptionAutoCompleteTextView) bindings[5];
        this.mboundView5.setTag(null);
        setRootTag(root);
        // listeners
        invalidateAll();
    }

    @Override
    public void invalidateAll() {
        synchronized(this) {
                mDirtyFlags = 0x10000L;
        }
        requestRebind();
    }

    @Override
    public boolean hasPendingBindings() {
        synchronized(this) {
            if (mDirtyFlags != 0) {
                return true;
            }
        }
        return false;
    }

    @Override
    public boolean setVariable(int variableId, @Nullable Object variable)  {
        boolean variableSet = true;
        if (BR.minScoreVisible == variableId) {
            setMinScoreVisible((boolean) variable);
        }
        else if (BR.deadlineDate == variableId) {
            setDeadlineDate((long) variable);
        }
        else if (BR.caGracePeriodError == variableId) {
            setCaGracePeriodError((java.lang.String) variable);
        }
        else if (BR.gracePeriodDate == variableId) {
            setGracePeriodDate((long) variable);
        }
        else if (BR.caStartDateError == variableId) {
            setCaStartDateError((java.lang.String) variable);
        }
        else if (BR.block == variableId) {
            setBlock((com.ustadmobile.lib.db.entities.CourseBlock) variable);
        }
        else if (BR.gracePeriodVisibility == variableId) {
            setGracePeriodVisibility((int) variable);
        }
        else if (BR.caMaxPointsError == variableId) {
            setCaMaxPointsError((java.lang.String) variable);
        }
        else if (BR.timeZone == variableId) {
            setTimeZone((java.lang.String) variable);
        }
        else if (BR.gracePeriodTime == variableId) {
            setGracePeriodTime((long) variable);
        }
        else if (BR.completionCriteriaOptions == variableId) {
            setCompletionCriteriaOptions((java.util.List<com.ustadmobile.core.util.IdOption>) variable);
        }
        else if (BR.startTime == variableId) {
            setStartTime((long) variable);
        }
        else if (BR.completionCriteriaListener == variableId) {
            setCompletionCriteriaListener((com.ustadmobile.port.android.view.DropDownListAutoCompleteTextView.OnDropDownListItemSelectedListener<com.ustadmobile.core.util.IdOption>) variable);
        }
        else if (BR.startDate == variableId) {
            setStartDate((long) variable);
        }
        else if (BR.deadlineTime == variableId) {
            setDeadlineTime((long) variable);
        }
        else if (BR.caDeadlineError == variableId) {
            setCaDeadlineError((java.lang.String) variable);
        }
        else {
            variableSet = false;
        }
            return variableSet;
    }

    public void setMinScoreVisible(boolean MinScoreVisible) {
        this.mMinScoreVisible = MinScoreVisible;
        synchronized(this) {
            mDirtyFlags |= 0x1L;
        }
        notifyPropertyChanged(BR.minScoreVisible);
        super.requestRebind();
    }
    public void setDeadlineDate(long DeadlineDate) {
        this.mDeadlineDate = DeadlineDate;
        synchronized(this) {
            mDirtyFlags |= 0x2L;
        }
        notifyPropertyChanged(BR.deadlineDate);
        super.requestRebind();
    }
    public void setCaGracePeriodError(@Nullable java.lang.String CaGracePeriodError) {
        this.mCaGracePeriodError = CaGracePeriodError;
        synchronized(this) {
            mDirtyFlags |= 0x4L;
        }
        notifyPropertyChanged(BR.caGracePeriodError);
        super.requestRebind();
    }
    public void setGracePeriodDate(long GracePeriodDate) {
        this.mGracePeriodDate = GracePeriodDate;
        synchronized(this) {
            mDirtyFlags |= 0x8L;
        }
        notifyPropertyChanged(BR.gracePeriodDate);
        super.requestRebind();
    }
    public void setCaStartDateError(@Nullable java.lang.String CaStartDateError) {
        this.mCaStartDateError = CaStartDateError;
        synchronized(this) {
            mDirtyFlags |= 0x10L;
        }
        notifyPropertyChanged(BR.caStartDateError);
        super.requestRebind();
    }
    public void setBlock(@Nullable com.ustadmobile.lib.db.entities.CourseBlock Block) {
        this.mBlock = Block;
        synchronized(this) {
            mDirtyFlags |= 0x20L;
        }
        notifyPropertyChanged(BR.block);
        super.requestRebind();
    }
    public void setGracePeriodVisibility(int GracePeriodVisibility) {
        this.mGracePeriodVisibility = GracePeriodVisibility;
        synchronized(this) {
            mDirtyFlags |= 0x40L;
        }
        notifyPropertyChanged(BR.gracePeriodVisibility);
        super.requestRebind();
    }
    public void setCaMaxPointsError(@Nullable java.lang.String CaMaxPointsError) {
        this.mCaMaxPointsError = CaMaxPointsError;
        synchronized(this) {
            mDirtyFlags |= 0x80L;
        }
        notifyPropertyChanged(BR.caMaxPointsError);
        super.requestRebind();
    }
    public void setTimeZone(@Nullable java.lang.String TimeZone) {
        this.mTimeZone = TimeZone;
        synchronized(this) {
            mDirtyFlags |= 0x100L;
        }
        notifyPropertyChanged(BR.timeZone);
        super.requestRebind();
    }
    public void setGracePeriodTime(long GracePeriodTime) {
        this.mGracePeriodTime = GracePeriodTime;
        synchronized(this) {
            mDirtyFlags |= 0x200L;
        }
        notifyPropertyChanged(BR.gracePeriodTime);
        super.requestRebind();
    }
    public void setCompletionCriteriaOptions(@Nullable java.util.List<com.ustadmobile.core.util.IdOption> CompletionCriteriaOptions) {
        this.mCompletionCriteriaOptions = CompletionCriteriaOptions;
        synchronized(this) {
            mDirtyFlags |= 0x400L;
        }
        notifyPropertyChanged(BR.completionCriteriaOptions);
        super.requestRebind();
    }
    public void setStartTime(long StartTime) {
        this.mStartTime = StartTime;
        synchronized(this) {
            mDirtyFlags |= 0x800L;
        }
        notifyPropertyChanged(BR.startTime);
        super.requestRebind();
    }
    public void setCompletionCriteriaListener(@Nullable com.ustadmobile.port.android.view.DropDownListAutoCompleteTextView.OnDropDownListItemSelectedListener<com.ustadmobile.core.util.IdOption> CompletionCriteriaListener) {
        this.mCompletionCriteriaListener = CompletionCriteriaListener;
        synchronized(this) {
            mDirtyFlags |= 0x1000L;
        }
        notifyPropertyChanged(BR.completionCriteriaListener);
        super.requestRebind();
    }
    public void setStartDate(long StartDate) {
        this.mStartDate = StartDate;
        synchronized(this) {
            mDirtyFlags |= 0x2000L;
        }
        notifyPropertyChanged(BR.startDate);
        super.requestRebind();
    }
    public void setDeadlineTime(long DeadlineTime) {
        this.mDeadlineTime = DeadlineTime;
        synchronized(this) {
            mDirtyFlags |= 0x4000L;
        }
        notifyPropertyChanged(BR.deadlineTime);
        super.requestRebind();
    }
    public void setCaDeadlineError(@Nullable java.lang.String CaDeadlineError) {
        this.mCaDeadlineError = CaDeadlineError;
        synchronized(this) {
            mDirtyFlags |= 0x8000L;
        }
        notifyPropertyChanged(BR.caDeadlineError);
        super.requestRebind();
    }

    @Override
    protected boolean onFieldChange(int localFieldId, Object object, int fieldId) {
        switch (localFieldId) {
        }
        return false;
    }

    @Override
    protected void executeBindings() {
        long dirtyFlags = 0;
        synchronized(this) {
            dirtyFlags = mDirtyFlags;
            mDirtyFlags = 0;
        }
        boolean minScoreVisible = mMinScoreVisible;
        long deadlineDate = mDeadlineDate;
        int blockCbCompletionCriteria = 0;
        java.lang.String caGracePeriodError = mCaGracePeriodError;
        long gracePeriodDate = mGracePeriodDate;
        java.lang.String caStartDateError = mCaStartDateError;
        boolean caDeadlineErrorJavaLangObjectNull = false;
        com.ustadmobile.lib.db.entities.CourseBlock block = mBlock;
        java.lang.String caTimezoneAndroidStringClassTimezoneSetTimeZone = null;
        java.lang.String javaLangStringBlockCbLateSubmissionPenalty = null;
        int gracePeriodVisibility = mGracePeriodVisibility;
        java.lang.String caMaxPointsError = mCaMaxPointsError;
        boolean caStartDateErrorJavaLangObjectNull = false;
        java.lang.String timeZone = mTimeZone;
        boolean caGracePeriodErrorJavaLangObjectNull = false;
        long gracePeriodTime = mGracePeriodTime;
        boolean caMaxPointsErrorJavaLangObjectNull = false;
        java.util.List<com.ustadmobile.core.util.IdOption> completionCriteriaOptions = mCompletionCriteriaOptions;
        int blockCbMaxPoints = 0;
        long startTime = mStartTime;
        com.ustadmobile.port.android.view.DropDownListAutoCompleteTextView.OnDropDownListItemSelectedListener<com.ustadmobile.core.util.IdOption> completionCriteriaListener = mCompletionCriteriaListener;
        int blockCbLateSubmissionPenalty = 0;
        java.lang.String javaLangStringBlockCbMaxPoints = null;
        long startDate = mStartDate;
        long deadlineTime = mDeadlineTime;
        int minScoreVisibleViewVISIBLEViewGONE = 0;
        java.lang.String caDeadlineError = mCaDeadlineError;

        if ((dirtyFlags & 0x10001L) != 0) {

            if((dirtyFlags & 0x10001L) != 0) {
                if(minScoreVisible) {
                        dirtyFlags |= 0x40000L;
                }
                else {
                        dirtyFlags |= 0x20000L;
                }
            }


                // read minScoreVisible ? View.VISIBLE : View.GONE
                minScoreVisibleViewVISIBLEViewGONE = ((minScoreVisible) ? (android.view.View.VISIBLE) : (android.view.View.GONE));
        }
        if ((dirtyFlags & 0x10102L) != 0) {
        }
        if ((dirtyFlags & 0x10004L) != 0) {



                // read caGracePeriodError != null
                caGracePeriodErrorJavaLangObjectNull = (caGracePeriodError) != (null);
        }
        if ((dirtyFlags & 0x10108L) != 0) {
        }
        if ((dirtyFlags & 0x10010L) != 0) {



                // read caStartDateError != null
                caStartDateErrorJavaLangObjectNull = (caStartDateError) != (null);
        }
        if ((dirtyFlags & 0x10420L) != 0) {



                if (block != null) {
                    // read block.cbCompletionCriteria
                    blockCbCompletionCriteria = block.getCbCompletionCriteria();
                }
            if ((dirtyFlags & 0x10020L) != 0) {

                    if (block != null) {
                        // read block.cbMaxPoints
                        blockCbMaxPoints = block.getCbMaxPoints();
                        // read block.cbLateSubmissionPenalty
                        blockCbLateSubmissionPenalty = block.getCbLateSubmissionPenalty();
                    }


                    // read ("") + (block.cbMaxPoints)
                    javaLangStringBlockCbMaxPoints = ("") + (blockCbMaxPoints);
                    // read ("") + (block.cbLateSubmissionPenalty)
                    javaLangStringBlockCbLateSubmissionPenalty = ("") + (blockCbLateSubmissionPenalty);
            }
        }
        if ((dirtyFlags & 0x10040L) != 0) {
        }
        if ((dirtyFlags & 0x10080L) != 0) {



                // read caMaxPointsError != null
                caMaxPointsErrorJavaLangObjectNull = (caMaxPointsError) != (null);
        }
        if ((dirtyFlags & 0x1210aL) != 0) {


            if ((dirtyFlags & 0x10100L) != 0) {

                    // read @android:string/class_timezone_set
                    caTimezoneAndroidStringClassTimezoneSetTimeZone = caTimezone.getResources().getString(R.string.class_timezone_set, timeZone);
            }
            if ((dirtyFlags & 0x10108L) != 0) {
            }
            if ((dirtyFlags & 0x10102L) != 0) {
            }
        }
        if ((dirtyFlags & 0x10200L) != 0) {
        }
        if ((dirtyFlags & 0x10800L) != 0) {
        }
        if ((dirtyFlags & 0x11000L) != 0) {
        }
        if ((dirtyFlags & 0x12100L) != 0) {
        }
        if ((dirtyFlags & 0x14000L) != 0) {
        }
        if ((dirtyFlags & 0x18000L) != 0) {



                // read caDeadlineError != null
                caDeadlineErrorJavaLangObjectNull = (caDeadlineError) != (null);
        }
        // batch finished
        if ((dirtyFlags & 0x10000L) != 0) {
            // api target 3
            if(getBuildSdkInt() >= 3) {

                this.caDeadlineDate.setInputType(android.text.InputType.TYPE_NULL);
                this.caGraceDate.setInputType(android.text.InputType.TYPE_NULL);
                this.caStartDate.setInputType(android.text.InputType.TYPE_NULL);
                this.mboundView13.setInputType(android.text.InputType.TYPE_NULL);
                this.mboundView17.setInputType(android.text.InputType.TYPE_NULL);
                this.mboundView3.setInputType(android.text.InputType.TYPE_NULL);
            }
            // api target 1

            com.ustadmobile.port.android.view.binding.DatePickerBindingAdapter2Kt.setDateTimeInMillisChanged(this.caDeadlineDate, caDeadlineDatedateTimeInMillisAttrChanged);
            com.ustadmobile.port.android.view.binding.EditTextBindingsKt.setRunOnClickWhenFocused(this.caDeadlineDate, true);
            this.caDeadlineDateTextinput.setHint(com.ustadmobile.port.android.view.ext.StringExtKt.optional(getRoot().getContext(), caDeadlineDateTextinput.getResources().getString(R.string.deadline)));
            androidx.databinding.adapters.TextViewBindingAdapter.setTextWatcher(this.caEditMaxScore, (androidx.databinding.adapters.TextViewBindingAdapter.BeforeTextChanged)null, (androidx.databinding.adapters.TextViewBindingAdapter.OnTextChanged)null, (androidx.databinding.adapters.TextViewBindingAdapter.AfterTextChanged)null, caEditMaxScoreandroidTextAttrChanged);
            androidx.databinding.adapters.TextViewBindingAdapter.setTextWatcher(this.caEditMinScore, (androidx.databinding.adapters.TextViewBindingAdapter.BeforeTextChanged)null, (androidx.databinding.adapters.TextViewBindingAdapter.OnTextChanged)null, (androidx.databinding.adapters.TextViewBindingAdapter.AfterTextChanged)null, caEditMinScoreandroidTextAttrChanged);
            com.ustadmobile.port.android.view.binding.EditTextBindingsKt.setMinMax(this.caEditPenalty, 0, 100);
            androidx.databinding.adapters.TextViewBindingAdapter.setTextWatcher(this.caEditPenalty, (androidx.databinding.adapters.TextViewBindingAdapter.BeforeTextChanged)null, (androidx.databinding.adapters.TextViewBindingAdapter.OnTextChanged)null, (androidx.databinding.adapters.TextViewBindingAdapter.AfterTextChanged)null, caEditPenaltyandroidTextAttrChanged);
            com.ustadmobile.port.android.view.binding.DatePickerBindingAdapter2Kt.setDateTimeInMillisChanged(this.caGraceDate, caGraceDatedateTimeInMillisAttrChanged);
            com.ustadmobile.port.android.view.binding.EditTextBindingsKt.setRunOnClickWhenFocused(this.caGraceDate, true);
            androidx.databinding.adapters.TextViewBindingAdapter.setText(this.caPenaltyTextLabel, caPenaltyTextLabel.getResources().getString(R.string.penalty_label));
            com.ustadmobile.port.android.view.binding.DatePickerBindingAdapter2Kt.setDateTimeInMillisChanged(this.caStartDate, caStartDatedateTimeInMillisAttrChanged);
            com.ustadmobile.port.android.view.binding.EditTextBindingsKt.setRunOnClickWhenFocused(this.caStartDate, true);
            this.caStartDateTextinput.setHint(com.ustadmobile.port.android.view.ext.StringExtKt.optional(getRoot().getContext(), caStartDateTextinput.getResources().getString(R.string.dont_show_before)));
            com.ustadmobile.port.android.view.binding.TimePickerBindingAdapterKt.getTime(this.mboundView13, mboundView13timeValueAttrChanged);
            com.ustadmobile.port.android.view.binding.EditTextBindingsKt.setRunOnClickWhenFocused(this.mboundView13, true);
            com.ustadmobile.port.android.view.binding.TimePickerBindingAdapterKt.getTime(this.mboundView17, mboundView17timeValueAttrChanged);
            com.ustadmobile.port.android.view.binding.EditTextBindingsKt.setRunOnClickWhenFocused(this.mboundView17, true);
            com.ustadmobile.port.android.view.binding.TimePickerBindingAdapterKt.getTime(this.mboundView3, mboundView3timeValueAttrChanged);
            com.ustadmobile.port.android.view.binding.EditTextBindingsKt.setRunOnClickWhenFocused(this.mboundView3, true);
            com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.setSelectedMessageIdListener(this.mboundView5, mboundView5selectedMessageIdOptionAttrChanged);
        }
        if ((dirtyFlags & 0x10102L) != 0) {
            // api target 1

            com.ustadmobile.port.android.view.binding.DatePickerBindingAdapter2Kt.setDateTime2(this.caDeadlineDate, deadlineDate, timeZone, 0);
        }
        if ((dirtyFlags & 0x18000L) != 0) {
            // api target 1

            this.caDeadlineDateTextinput.setErrorEnabled(caDeadlineErrorJavaLangObjectNull);
            com.ustadmobile.port.android.view.binding.TextInputLayoutBindingsKt.setErrorText(this.caDeadlineDateTextinput, caDeadlineError);
            this.caDeadlineDatetimeTextinput.setErrorEnabled(caDeadlineErrorJavaLangObjectNull);
            com.ustadmobile.port.android.view.binding.TextInputLayoutBindingsKt.setErrorText(this.caDeadlineDatetimeTextinput, caDeadlineError);
        }
        if ((dirtyFlags & 0x10020L) != 0) {
            // api target 1

            androidx.databinding.adapters.TextViewBindingAdapter.setText(this.caEditMaxScore, javaLangStringBlockCbMaxPoints);
            androidx.databinding.adapters.TextViewBindingAdapter.setText(this.caEditMinScore, javaLangStringBlockCbMaxPoints);
            androidx.databinding.adapters.TextViewBindingAdapter.setText(this.caEditPenalty, javaLangStringBlockCbLateSubmissionPenalty);
        }
        if ((dirtyFlags & 0x10080L) != 0) {
            // api target 1

            this.caEditMaxScroreTextinput.setErrorEnabled(caMaxPointsErrorJavaLangObjectNull);
            com.ustadmobile.port.android.view.binding.TextInputLayoutBindingsKt.setErrorText(this.caEditMaxScroreTextinput, caMaxPointsError);
        }
        if ((dirtyFlags & 0x10040L) != 0) {
            // api target 1

            this.caEditPenaltyTextinput.setVisibility(gracePeriodVisibility);
            this.caGraceDateTextinput.setVisibility(gracePeriodVisibility);
            this.caGraceDatetimeTextinput.setVisibility(gracePeriodVisibility);
            this.caPenaltyTextLabel.setVisibility(gracePeriodVisibility);
        }
        if ((dirtyFlags & 0x10108L) != 0) {
            // api target 1

            com.ustadmobile.port.android.view.binding.DatePickerBindingAdapter2Kt.setDateTime2(this.caGraceDate, gracePeriodDate, timeZone, 0);
        }
        if ((dirtyFlags & 0x10004L) != 0) {
            // api target 1

            this.caGraceDateTextinput.setErrorEnabled(caGracePeriodErrorJavaLangObjectNull);
            com.ustadmobile.port.android.view.binding.TextInputLayoutBindingsKt.setErrorText(this.caGraceDateTextinput, caGracePeriodError);
            this.caGraceDatetimeTextinput.setErrorEnabled(caGracePeriodErrorJavaLangObjectNull);
            com.ustadmobile.port.android.view.binding.TextInputLayoutBindingsKt.setErrorText(this.caGraceDatetimeTextinput, caGracePeriodError);
        }
        if ((dirtyFlags & 0x12100L) != 0) {
            // api target 1

            com.ustadmobile.port.android.view.binding.DatePickerBindingAdapter2Kt.setDateTime2(this.caStartDate, startDate, timeZone, 0);
        }
        if ((dirtyFlags & 0x10010L) != 0) {
            // api target 1

            this.caStartDateTextinput.setErrorEnabled(caStartDateErrorJavaLangObjectNull);
            com.ustadmobile.port.android.view.binding.TextInputLayoutBindingsKt.setErrorText(this.caStartDateTextinput, caStartDateError);
        }
        if ((dirtyFlags & 0x10100L) != 0) {
            // api target 1

            androidx.databinding.adapters.TextViewBindingAdapter.setText(this.caTimezone, caTimezoneAndroidStringClassTimezoneSetTimeZone);
        }
        if ((dirtyFlags & 0x10001L) != 0) {
            // api target 1

            this.courseBlockMinScore.setVisibility(minScoreVisibleViewVISIBLEViewGONE);
        }
        if ((dirtyFlags & 0x14000L) != 0) {
            // api target 1

            com.ustadmobile.port.android.view.binding.TimePickerBindingAdapterKt.setTime(this.mboundView13, deadlineTime);
        }
        if ((dirtyFlags & 0x10200L) != 0) {
            // api target 1

            com.ustadmobile.port.android.view.binding.TimePickerBindingAdapterKt.setTime(this.mboundView17, gracePeriodTime);
        }
        if ((dirtyFlags & 0x10800L) != 0) {
            // api target 1

            com.ustadmobile.port.android.view.binding.TimePickerBindingAdapterKt.setTime(this.mboundView3, startTime);
        }
        if ((dirtyFlags & 0x11000L) != 0) {
            // api target 1

            com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.setOnMessageIdOptionSelected(this.mboundView5, completionCriteriaListener);
        }
        if ((dirtyFlags & 0x10420L) != 0) {
            // api target 1

            com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.setMessageIdOptions(this.mboundView5, completionCriteriaOptions, blockCbCompletionCriteria);
        }
    }
    // Listener Stub Implementations
    // callback impls
    // dirty flag
    private  long mDirtyFlags = 0xffffffffffffffffL;
    /* flag mapping
        flag 0 (0x1L): minScoreVisible
        flag 1 (0x2L): deadlineDate
        flag 2 (0x3L): caGracePeriodError
        flag 3 (0x4L): gracePeriodDate
        flag 4 (0x5L): caStartDateError
        flag 5 (0x6L): block
        flag 6 (0x7L): gracePeriodVisibility
        flag 7 (0x8L): caMaxPointsError
        flag 8 (0x9L): timeZone
        flag 9 (0xaL): gracePeriodTime
        flag 10 (0xbL): completionCriteriaOptions
        flag 11 (0xcL): startTime
        flag 12 (0xdL): completionCriteriaListener
        flag 13 (0xeL): startDate
        flag 14 (0xfL): deadlineTime
        flag 15 (0x10L): caDeadlineError
        flag 16 (0x11L): null
        flag 17 (0x12L): minScoreVisible ? View.VISIBLE : View.GONE
        flag 18 (0x13L): minScoreVisible ? View.VISIBLE : View.GONE
    flag mapping end*/
    //end
}